function itc = com_itc_BS_2( Y, D, X, rmse )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Return:
%    itc : extended criteria that have been used in the prev. exp.
%          and novel extended criteria
% The first two entries are derived from BIC
% The next two entries are derived from RNML1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


[m,N] = size(Y);
[~,n] = size(D);

T = m*N;
gof = 2*log(rmse);
fx = (X(:)~=0);
nop = sum( fx );
nop2 = nop + (m-1)*n; %Here I have replaced (m-2) with (m-1)
s = round(nop/N);

itc     = Inf(4,1);

%Extra penalties
epen1   = gammaln(n+1) -gammaln(s+1) -gammaln(n-s+1);
epen2   = 2*nop*log(n);

%BIC
bic        = gof + (log(T)/T)*nop2;
itc(1)     = bic + (2*N/T)*epen1;
itc(2)     = bic + (2/T)*epen2; 

%RNML
Xbetnorm = 0;
for ind = 1:size(X,2)
    xx = X(:,ind);
    fxx = find(xx~=0);
    xx = xx(fxx);
    DD = D(:,fxx);
    Xbetnorm = Xbetnorm + norm(DD*xx)^2;      
end

term    = zeros(3,1); 
term(1) = (T-nop2)*log(rmse^2/(T-nop2));
term(2) = nop2*log( Xbetnorm/T/nop2 );
term(3) = log( nop2*(T-nop2) );
rnml    = sum(term); 

itc(3)  = rnml + 2*N*epen1;
itc(4)  = rnml + 2*epen2;

end %function

